--     ____                _       __
--    / __ )____  _____   | |     / /___ ___________
--   / __  / __ \/ ___/   | | /| / / __ `/ ___/ ___/
--  / /_/ / /_/ (__  )    | |/ |/ / /_/ / /  (__  )
-- /_____/\____/____/     |__/|__/\__,_/_/  /____/
--
--       A futuristic real-time strategy game.
--          This file is part of Bos Wars.
--
-- Copyright 2008 Francois Beerten
-- File licensed under the GNU GPL version 2 or later.

DefineImageTilemodels(GetCurrentLuaPath().."/terrain.png", 8, 8*6)

Load(GetCurrentLuaPath().."/access-fast.lua")

function DefinePatch(r, w, h)
  local f = function(x, y)
      local i
      local j
      for i = 0, h-1 do
        for j = 0, w-1 do
            SetTile((r+i)*8+j, x+j, y+i)
        end
      end
  end
  return f
end

function DefineTile(offset)
  local f = function(x, y, w)
     SetTile(offset, x, y)
  end
  return f
end
function DrawHorizontalRoad(x, y, w)
    for j = 0, w-1 do
       SetTile(8*8, x+j, y)
    end
end
function DrawVerticalRoad(x, y, w)
    for j = 0, w-1 do
       SetTile(8*8+1, x, y+j)
    end
end


grass = DefinePatch(0, 8, 8)
roadtd = DefineTile(8*8+2)
roadtu = DefineTile(8*8+3)
roadtl = DefineTile(8*8+4)
roadtr = DefineTile(8*8+5)
roadx = DefineTile(8*8+7)

for i = 0, 31 do
  for j = 0, 31 do
    grass(i*8, j*8)
  end
end

DrawHorizontalRoad(0, 52, 256)
DrawHorizontalRoad(0, 204, 256)
DrawVerticalRoad(52, 0, 256)
DrawVerticalRoad(204, 0, 256)
roadx(52, 52)
roadx(52, 204)
roadx(204, 52)
roadx(204, 204)
DrawHorizontalRoad(52, 128, 152)
DrawVerticalRoad(128, 52, 152)
roadx(128,128)
roadtd(128, 52)
roadtu(128, 204)
roadtl(52, 128)
roadtr(204, 128)


Editor.TerrainEditable = false
