--       _________ __                 __                               
--      /   _____//  |_____________ _/  |______     ____  __ __  ______
--      \_____  \\   __\_  __ \__  \\   __\__  \   / ___\|  |  \/  ___/
--      /        \|  |  |  | \// __ \|  |  / __ \_/ /_/  >  |  /\___ \ 
--     /_______  /|__|  |__|  (____  /__| (____  /\___  /|____//____  >
--             \/                  \/          \//_____/            \/ 
--  ______________________                           ______________________
--  T H E   W A R   B E G I N S
--   Stratagus - A free fantasy real time strategy game engine
--
--	terrain.lua - Define image based terrain
--
--      (c) Copyright 2005 by Franois Beerten.
--
--      This program is free software; you can redistribute it and/or modify
--      it under the terms of the GNU General Public License as published by
--      the Free Software Foundation; either version 2 of the License, or
--      (at your option) any later version.
--  
--      This program is distributed in the hope that it will be useful,
--      but WITHOUT ANY WARRANTY; without even the implied warranty of
--      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--      GNU General Public License for more details.
--  
--      You should have received a copy of the GNU General Public License
--      along with this program; if not, write to the Free Software
--      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
-- $Id: terrain.lua 191 2005-07-31 16:20:38Z feb $


DefineImageTilemodels(GetCurrentLuaPath().."/terrain.png", 16, 96)

Load(GetCurrentLuaPath().."/access-unpassable.lua")

function DefinePatch(r, w, h)
  local f = function(x, y)
      local i
      local j
      for i = 0, h-1 do
        for j = 0, w-1 do
            SetTile((r+i)*16+j, x+j, y+i)
        end
      end
  end
  return f
end

Butte1 = DefinePatch(0, 16, 16)
Butte2 = DefinePatch(16, 16, 16)
Butte3 = DefinePatch(32, 16, 16)
Pond1 = DefinePatch(48, 16, 16)
Pond2 = DefinePatch(64, 16, 16)
Grass1 = DefinePatch(80, 16, 16)

-- tile plain
Grass1(0,0)
Grass1(16,0)
Grass1(32,0)
Grass1(48,0)
Grass1(0,16)
Grass1(16,16)
Grass1(32,16)
Grass1(48, 16)
Grass1(0,32)
Grass1(0,32)
Grass1(16,32)
Grass1(32,32)
Grass1(48, 32)
Grass1(0, 48)
Grass1(16, 48)
Grass1(32,48)
Grass1(48, 48)
-- place features
Pond2(6,8)
Butte3(36,8)
Butte1(24, 24)
Pond1(37, 42)
Butte2(12, 48)


Editor.TerrainEditable = false
